import ResizeObserver from 'resize-observer-polyfill';
var ElementRectObserver = (function () {
    function ElementRectObserver(listener, container) {
        var _this = this;
        if (container === void 0) { container = window; }
        this.onChange = function () {
            var _a;
            _this.listener((_a = _this.target) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect());
        };
        this.listener = listener;
        this.container = container;
        this.resizeObserver = new ResizeObserver(this.onChange);
        this.intersectionObserver = new IntersectionObserver(this.onChange);
        this.mutationObserver = new MutationObserver(this.onChange);
    }
    ElementRectObserver.prototype.observe = function (element) {
        var _a, _b;
        this.target = element;
        this.resizeObserver.observe(element);
        this.intersectionObserver.observe(element);
        this.mutationObserver.observe(element === null || element === void 0 ? void 0 : element.parentNode, {
            childList: true,
        });
        if (((_b = (_a = this.container) === null || _a === void 0 ? void 0 : _a.toString()) === null || _b === void 0 ? void 0 : _b.indexOf('Window')) === -1) {
            this.resizeObserver.observe(this.container);
        }
        else {
            this.container.addEventListener('resize', this.onChange);
        }
        this.container.addEventListener('scroll', this.onChange);
    };
    ElementRectObserver.prototype.unobserve = function (element) {
        var _a, _b;
        this.target = null;
        this.resizeObserver.unobserve(element);
        this.intersectionObserver.unobserve(element);
        this.mutationObserver.disconnect();
        if (((_b = (_a = this.container) === null || _a === void 0 ? void 0 : _a.toString()) === null || _b === void 0 ? void 0 : _b.indexOf('Window')) === -1) {
            this.resizeObserver.unobserve(this.container);
        }
        else {
            this.container.removeEventListener('resize', this.onChange);
        }
        this.container.removeEventListener('scroll', this.onChange);
    };
    return ElementRectObserver;
}());
export { ElementRectObserver };
