import { useEffect, useRef } from 'react';
import { ElementRectObserver } from './ElementRectObserver';
export var useElementRectObserver = function (element, callback, container) {
    var lastElement = useRef();
    useEffect(function () {
        var resizeObserver = new ElementRectObserver(function (rect) {
            if (typeof callback === 'function')
                callback(rect);
        }, container);
        if (element) {
            if (lastElement.current && element !== lastElement.current) {
                resizeObserver.unobserve(lastElement.current);
            }
            resizeObserver.observe(element);
            lastElement.current = element;
        }
        return function () {
            if (element) {
                resizeObserver.unobserve(element);
            }
        };
    }, [element]);
};
export default useElementRectObserver;
