"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useElementRectObserver = void 0;
var react_1 = require("react");
var ElementRectObserver_1 = require("./ElementRectObserver");
exports.useElementRectObserver = function (element, callback, container) {
    var lastElement = react_1.useRef();
    react_1.useEffect(function () {
        var resizeObserver = new ElementRectObserver_1.ElementRectObserver(function (rect) {
            if (typeof callback === 'function')
                callback(rect);
        }, container);
        if (element) {
            if (lastElement.current && element !== lastElement.current) {
                resizeObserver.unobserve(lastElement.current);
            }
            resizeObserver.observe(element);
            lastElement.current = element;
        }
        return function () {
            if (element) {
                resizeObserver.unobserve(element);
            }
        };
    }, [element]);
};
exports.default = exports.useElementRectObserver;
